 include "settings.inc"
  include "../ti83plus.inc"
 include "equates.inc" 
 SEGMENT Main
 GLOBALS ON
 EXTERN IPutS,IGetKey,USBSaveSP,USBInfo,DispHexA,WaitTimer2,WaitTimer4,WaitTimer1,USBErrorPort82
 EXTERN USBErrorPort8F,USBErrorPort8C,USBErrorPort91Bit2,USBErrorPort91Bit4,USBErrorPort81
 EXTERN USBErrorPort3A,USBErrorPort4D,USBErrorPort4C,SetAddress,GetMaxPacketSize,SetupUSBHook
 EXTERN USBErrorPort91Bit2Pop1,USBErrorPort91Bit4Pop1,USBErrorPort82Pop2,WaitTimer32,USBErrorSetAddress
 EXTERN USBErrorGetMaxPacketSize,IPutC,DoAssert,GetMaxPacketSizeSafe,SetAddressSafe,USBErrorPort82Pop3
;USB low-level routines
;Stuff that plays directly with hardware


CalcIsHost:
;Z = device is host
       in     a,(4Dh)
       cpl
       bit    4,a
       ret

GetPipeInfo:
;Return direction, type, and packet size for pipe B
;Output
; B = 20h or 30h for bulk or interrupt
; C = packet size
; D = pipeIn and/or pipeOut
; NC = success


       DISAVE
       ld     a,b
       out    (8Eh),a
       in     a,(9Ah)
       or     a
       jr     z,GetPipeInfoOut
       and    0F0h
       ld     b,a

       ld     d,pipeIn
       in     a,(98h)              
       or     a                    ;Both I and O pipe?
       jr     z,$f
       ld     d,pipeIn+pipeOut
$$:
       in     a,(93h)
       or     a
       jr     nz,GetPipeInfoDone
       in     a,(90h)

GetPipeInfoDone:
       and    3
       add    a,a
       add    a,a
       add    a,a
       ld     c,a
GetPipeInfoEIRet:
       EIRESTORE
       ret

GetPipeInfoOut:
       in     a,(98h)
       or     a
       scf
       jr     z,GetPipeInfoEIRet
       and    0F0h
       ld     b,a
       in     a,(90h)
       ld     d,pipeOut
       jr     GetPipeInfoDone


KillUSBDevice:
       LOG    KillDevice
       rst    28h
       dw     5293h
       ret

IsDeviceConnected:
       in     a,(4Dh)
       bit    4,a
       ret

SetupOutPipe:
       call   SetPacketSize

USBInitOutPipe:
;Initialize pipe/endpoint number B
;C = 30 = interrupt
;C = 20 = bulk
;D = packetsize/8
;E = polling interval

       ASSERTC c,31h
       ASSERTNC  c,20h
       ASSERTNC 4,b
       ASSERTC d,9

       xor    a
       out    (5Bh),a
       ld     a,b
       out    (8Eh),a
       or     c
       out    (98h),a
       ld     a,d
       out    (90h),a
       ld     a,0FFh
       out    (87h),a
       xor    a
       out    (92h),a

;       ld     a,e
;       out    (99h),a       ;What can this be necessary for?

;       ld     a,0A1h
;       out    (8Bh),a
       ld     a,1
       out    (5Bh),a
       ret


SetPacketSize:
       push   de
       ld     a,d
       add    a,a
       add    a,a
       add    a,a
       ld     e,b
       ld     d,0
       ld     hl,(MemPtr)
       push   hl
       add    hl,de
       ld     de,offPacketSizeTable
       add    hl,de
       ld     (hl),a
       pop    hl
       pop    de
       ret
SetupInPipe:
;Same as initinpipe, but HL -> callback routine       
       push   de
;       push   hl
       call   SetPacketSize
;       ld     e,b
;       ld     d,0
;       sla    e
;       add    hl,de
;       ld     de,offCallBackTable
;       add    hl,de
;       ex     de,hl
;       pop    hl
;       ld     a,l
;       ld     (de),a
;       inc    de
;       ld     a,h
;       ld     (de),a
       pop    de

USBInitInPipe:
;Initialize pipe/endpoint number B
;C = 30 = interrupt
;C = 20 = bulk
;D = packetsize/8
;E = polling interval

       ASSERTC c,31h
       ASSERTNC  c,20h
       ASSERTNC 4,b
       ASSERTC d,9

       xor    a
       out    (5Bh),a
       ld     a,b
       out    (8Eh),a
       or     c
       out    (9Ah),a
       ld     a,d
       out    (93h),a

       ld     a,90h
       out    (94h),a

       xor    a
       out    (95h),a

       ld     a,c
       cp     20h
       jr     z,$f
       ld     a,e
       out    (9Bh),a       ;Is this ok for bulk endpoints?  Will it ignore?
$$:
       ld     a,0Eh         ;I don't know what to pick for this value...
       out    (89h),a
       ld     a,1
       out    (5Bh),a
       ret                  

USBReqData:
;Send an IN token on pipe/endpoint B
       ld     a,b
       out    (8Eh),a
       ld     a,20h
       out    (94h),a
       ret




USBHostInit:
       DISAVE
       call   USBHostInitSafe
       EIRESTORE
       ret


USBHostInitSafe:
;Initialize the USB Host
;Peripheral initialization is very similar, but hasn't yet been tested.
; NC = success

 COMMENT ~
       in     a,(8Fh)
       or     a
       jr     z,$f
       DEBUG  1
       call   KillUSBDevice
       call   WaitTimer32
$$:
 ~

       LOG    HostInit
       in     a,(4Ch)
       cp     05Ah
       ret    z
       cp     1Ah
       ret    z

InitNewDevice:                     ;Test call to init new device (from hub) w/o total reinit (doesn't work)
;reinit tried initted hub instead of mouse

       in     a,(4Dh)                     ;******TESTING
       bit    5,a                         ;******TESTING
       jr     z,$f                        ;******TESTING
       ld     a,10h                       ;******TESTING
       out    (57h),a                     ;******TESTING
$$:                                       ;******TESTING

       xor    a
       out    (4Ch),a
       ld     a,1
       out    (5Bh),a
       ld     a,2
       out    (54h),a
       ld     a,20h
       out    (4ah),a


	xor	a
	out	(4Bh),a
       call   Bit3Port3A
       jr     z,$f
       ld     a,20h
       out    (4Bh),a
$$:
       xor    a
       out    (54h),a
       call   WaitTimer1
       call   Bit3Port3A
       jr     z,$f
       ld     a,44h
       out    (54h),a
$$:
       ld     a,0C4h
       out    (54h),a
       ld     de,0FFFFh
$$:
       ld     a,e
       or     d
       jp     z,USBErrorPort4C
       dec    de
       in     a,(4Ch)
       and    10111111b
       cp     12h                  ;Check port 4C to be 12h or 52h
       jr     nz,$b
       in     a,(4Dh)
       bit    5,a
       jp     nz,USBErrorPort4D
       call   Bit3Port3A
;       jp     nz,USBErrorPort3A
       jr     z,InitBoot102Code
                                   ;Skipping 6,4D check

       call   WaitTimer1           ;******TESTING
       in     a,(4Dh)              ;******TESTING
       LOG    Custom,4Dh           ;******TESTING
       LOG    Custom,a             ;******TESTING       
       bit    6,a                  ;******TESTING
       jr     nz,USBErrorPort4D    ;******TESTING
       
       in     a,(3Ah)
       res    1,a
       out    (3Ah),a
       in     a,(39h)
       set    1,a
       out    (39h),a              ;This stuff must do some kind of enabling of something
       ld     a,8                  ; so that the 4C and 8F port changes can stick.
       out    (4Ch),a              ; but why?
       ld     a,1
       out    (8Fh),a
       ld     de,0FFFFh
$$:
       dec    de
       ld     a,d
       or     e
       jp     z,USBErrorPort4D
       in     a,(4Dh)
       bit    6,a                  ;Check to see if initialized (powered?)
       jr     z,$b
       in     a,(39h)
       res    1,a
       out    (39h),a
       jr     InitCont

InitBoot102Code:
       LOG    Custom,0BBh
       ld     a,8
       out    (4Ch),a
       ld     de,0FFFFh
$$:      
       dec    de
       ld     a,e
       or     d
       jp     z,USBErrorPort81
       in     a,(81h)
       bit    5,a
       jr     nz,$b

       ld     a,1
       out    (8Fh),a
       call   WaitTimer2
;reinit tried
InitCont:

	ld	a,0FFh
	out	(87h),a
	xor	a
	out	(92h),a
	ld	a,0Eh
	out	(89h),a
	ld	a,0A1h           ;This would have been 05 if this were a peripheral init
	out	(8Bh),a
       in     a,(86h)              ;******TESTING
       ld     de,0FFFFh
testloop:
       dec    de
       ld     a,d
       or     e
       jr     z,USBErrorPort81
	in	a,(81h)
       bit    6,a
       jr     z,testloop
	in	a,(8Fh)
	bit	2,a
	jp	z,USBErrorPort8F
       ld     b,5
Loop8C:
       ld     de,0FFFFh
$$:
       in     a,(8Ch)
       or     a
       jr     nz,$f
       dec    de
       ld     a,d
       or     e
       jp     nz,$b
       djnz   Loop8C
       jp     USBErrorPort8C
$$:
;reinit tried initted hub instead of mouse
	xor	a
	out	(5Bh),a
;reinit tried 1701 error
	ld	a,8	
	out	(81h),a
       call   WaitTimer2
	xor	a
	out	(81h),a
       call   WaitTimer4
;reinit tried 1701 error
;       xor    a             ;******TESTING
;       out    (8Eh),a       ;******TESTING
;       call   WaitTimer1    ;******TESTING
;       xor    a             ;******TESTING
;       out    (91h),a       ;******TESTING
;       call   WaitTimer1    ;******TESTING
       xor    a             ;Clear Address
	out	(80h),a
       call   WaitTimer1    ;******TESTING
       call   GetMaxPacketSizeSafe
       jp     c,USBErrorGetMaxPacketSize
       call   WaitTimer2           ;******TESTING
       call   SetAddressSafe
       jp     c,USBErrorSetAddress
;       jp     SetupUSBHook                ;Why only on successful init?
       ret



SendOutCmdNoWait:
;Same as below but doesn't check port 82 for confirmation
;NC = success
       ld     a,b
       out    (8Eh),a
       ld     a,c
       out    (91h),a
       jp     CheckPort91
              


ResetPort82Flag:
       push   hl
       push   de
       ld     hl,(MemPtr)
       ld     de,offFlags
       add    hl,de
       res    flagPort82,(hl)
       pop    de
       pop    hl
       ret

SendOutCmdWait:
;Sends command C on endpoint B to port 91
;Waits for respons from Port 82
;Checks for error port port 91
; NC = success

       call   ResetPort82Flag

       ld     a,b
       out    (8Eh),a
       ld     a,c
       out    (91h),a
       call   WaitPort82
       ret    c
       jp     CheckPort91

SendControlCmd:
;Send a command via port 91 on endpoint 0
;NC = success
       push   af

       call   ResetPort82Flag
       xor    a
       out    (8Eh),a
       pop    af
       out    (91h),a
       call   WaitPort82
       ret    c
       jp     CheckPort91

CheckUSBActive:
       in     a,(8Ch)
       halt
       ld     b,a
       in     a,(8Ch)
       or     b
       ret

CheckPort91:
;Checks if there is an error condition on port 91 (bits 2 or 4 set)
       push   af
       in     a,(91h)
       bit    2,a
       jr     nz,USBErrorPort91Bit2Pop1
       bit    4,a
       jr     nz,USBErrorPort91Bit4Pop1
       pop    af
       or     a
       ret

WaitPort82:
;Wait for port 82 to acknowledge that the previous command is done
;Will error if timed out for port 82       
       push   af
       push   de
       push   hl
       push   bc
       ld     hl,(MemPtr)
       ld     de,offFlags
       add    hl,de
       ld     de,0FFFFh
$$:
       ld     a,d
       or     e
       jr     z,USBErrorPort82Pop3
       dec    de

       bit    flagPort82,(hl)
       jr     nz,$f

       in     a,(82h)
;       bit    0,a
       or     a
       jr     z,$b
$$:
       pop    bc
       pop    hl
       pop    de
       pop    af
       or     a
       ret



Bit3Port3A:
       push   bc
       push   af
       in     a,(3Ah)
       bit    3,a
       pop    bc
       ld     a,b
       pop    bc
       ret



SetHostAddress:
;Set local address via port 80
; A = address to set

       push   af
       xor    a
       out    (8Eh),a
;       out    (91h),a                     ;Are these necessary?
       pop    af
       out    (80h),a
       ret

   

Send8PortA0:
       ld     a,8
SendAPortA0:
       ld     b,a
SendBPortA0:
       LOG    OutA0Start,b
       LOG    DataStart,b
       xor    a
       out    (8Eh),a
$$:
       ld     a,(hl)
       LOG    Data,a
       out    (0A0h),a
       inc    hl
       djnz   $b
       LOG    DataEnd
       ret


Get8PortA0:
       ld     a,8
GetAPortA0:
       ld     b,a
GetBPortA0:
       LOG    InA0Start,b
       LOG    DataStart,b
       xor    a
       out    (8Eh),a
$$:
       in     a,(0A0h)
       LOG    Data,a
       ld     (hl),a
       inc    hl
       djnz   $b
       LOG    DataEnd
       ret

